package 
{
	import flash.desktop.NativeProcess;
	import flash.desktop.NativeProcessStartupInfo;
	import flash.display.Sprite;
	import flash.events.ProgressEvent;
	import flash.filesystem.File;
	import flash.text.TextField;
	/**
	 * ...
	 * @author umhr
	 */
	public class Main extends Sprite 
	{
		/**
		 * C#アプリケーションを呼び出すときに使う
		 */
		private var _fileName:String = 'ConsoleApplication1.exe';// C#アプリケーション
		
		/**
		 * C++アプリケーションを呼び出すときに使う
		 */
		//private var _fileName:String = '20110812c800.exe';// C++アプリケーション
		
		private var _file:File = File.applicationDirectory.resolvePath(_fileName);
		private var _nativeProcess:NativeProcess;
		private var _textFeild:TextField = new TextField();
		
		public function Main ()
		{
			init();
		}
		
		private function init():void {
			var text:String = "";
			var arguments:Vector.<String>;
			var nativeProcessStartupInfo:NativeProcessStartupInfo;
			if (NativeProcess.isSupported && _file.exists) {
				
				// 引数（不要なら付けなくても良い）
				arguments = new Vector.<String>();
				arguments[0] = 'from Adobe AIR';
				arguments[1] = 'Boo';
				
				nativeProcessStartupInfo = new NativeProcessStartupInfo();
				nativeProcessStartupInfo.arguments = arguments;
				nativeProcessStartupInfo.executable = _file;
				
				_nativeProcess = new NativeProcess();
				_nativeProcess.addEventListener(ProgressEvent.STANDARD_OUTPUT_DATA, onOutputData);
				_nativeProcess.start(nativeProcessStartupInfo);
				
				text += "NativeProcess.isSupported : " + NativeProcess.isSupported + "\n";
				text += "file.exists : " + _file.exists + "\n";
				text += "nativeProcess.running : " + _nativeProcess.running;
				
			}
			
			_textFeild.text = text;
			_textFeild.width = stage.stageWidth;
			_textFeild.height = stage.stageHeight;
			_textFeild.selectable = false;
			_textFeild.multiline = true;
			_textFeild.wordWrap = true;
			this.addChild(_textFeild);
		}
		
		/**
		 * 標準出力から読む
		 * @param	event
		 */
		private function onOutputData (event:ProgressEvent):void
		{
			_textFeild.text = _nativeProcess.standardOutput.readUTFBytes(_nativeProcess.standardOutput.bytesAvailable);
		}
	}
}